import 'reflect-metadata';
import { resolve as resolvePath } from 'path';
import { useSofa, OpenAPI } from 'sofa-api';
import * as swaggerUi from 'swagger-ui-express';
import fs from 'fs';
import express from 'express';
import { ApolloServer, makeExecutableSchema } from 'apollo-server-express';
import { express as voyagerMiddleware } from 'graphql-voyager/middleware';
import { createContext, getContextFromRequest } from './helpers';
import { asyncMiddleware } from './helpers/asyncMiddleware';
import { formatError } from './helpers/formatError';
import { formatResponse } from './helpers/formatResponse';
import cors from 'cors';
import bodyParser from 'body-parser';
import cookieParser from 'cookie-parser';
import session from 'express-session';
import { mergeSchema } from './utils/mergeSchema';
import { addMock } from './helpers/addMock';
import { config } from './config';

export const app = express();

asyncMiddleware(app); // enables async middlewares

async function bootstrap() {
  let typeDefs: string;
  if (process.env.NODE_ENV !== 'production') {
    typeDefs = mergeSchema(resolvePath(__dirname, 'schema'));
  } else {
    typeDefs = fs.readFileSync(resolvePath(__dirname, '../__snapshots__/schema.graphql')).toString();
  }

  const schema = makeExecutableSchema({
    typeDefs,
  });

  if (process.env.NODE_ENV !== 'production') {
    // persist merged schema type definitions to filesystem
    fs.writeFileSync(resolvePath(__dirname, '../__snapshots__/schema.graphql'), [
      '# -----------------------------------------------',
      '# !!! THIS FILE WAS GENERATED BY TYPE-GRAPHQL !!!',
      '# !!!   DO NOT MODIFY THIS FILE BY YOURSELF   !!!',
      '# -----------------------------------------------',
      typeDefs
    ].join('\n'));
  }

  addMock(schema);
  app.use(cors());
  app.use(bodyParser.json());
  app.use(bodyParser.urlencoded({
    extended: true
  }));

  // if (process.env.NODE_ENV !== 'production') {
    app.use(cookieParser());
    app.use(session({secret: 'development', resave: true, saveUninitialized: true}));
  // }

  app.use(async (req, res, next) => {
    const token = req.headers.authorization;
    if (token) {
      // @ts-ignore
      const ctx = getContextFromRequest(req);
      // TODO should put authentication logic here
    }
    next();
  });

  app.use((error: Error, req: any, res: any, next: any) => {
    res.json(formatResponse({ data: null, errors: [error] }));
  });


  const openApi = OpenAPI({
    schema,
    info: {
      title: 'Graph Integration',
      version: '1.0.2',
    },
  });

  app.use('/rest', useSofa({
    schema,
    onRoute(info) {
      openApi.addRoute(info, {
        basePath: '/rest',
      });
    },
  }));

  openApi.save('./swagger.yml');
  openApi.save('./swagger.json');

  app.use('/rest', swaggerUi.serve, swaggerUi.setup(require('../swagger.json')));


  app.get('/_graphview', voyagerMiddleware({ endpointUrl: '/' }));

  app.get('/healthcheck', (req, res) => {
    const response = {
      data: {
        stat: 'ok',
        time: Date.now(),
      },
    };
    res.json(formatResponse(response));
  });

  const graphqlServer = new ApolloServer({
    schema,
    context: createContext,
    formatError: formatError,
    introspection: true,
    playground: {
      settings: {
        'editor.theme': 'light',
        'request.credentials': 'include',
      },
      tabs: [
        {
          endpoint: '/',
          query: `query { me { userInfo { id, fullName } } }`,
        },
      ],
    },
  });

  app.use('/', graphqlServer.getMiddleware({ path: '/' }));

  return { graphqlServer };
}

bootstrap()
  .then(({ graphqlServer }) => {
    app.listen({ port: config.port }, () =>
      console.log(`🚀 Server ready at http://localhost:${config.port}${graphqlServer.graphqlPath}`)
    );
  })
  .catch(error => {
    console.error(error);
  });